<?php

/*
 +--------------------------------------------------------------------+
 | CiviCRM version 1.8                                                |
 +--------------------------------------------------------------------+
 | Copyright CiviCRM LLC (c) 2004-2007                                |
 +--------------------------------------------------------------------+
 | This file is a part of CiviCRM.                                    |
 |                                                                    |
 | CiviCRM is free software; you can copy, modify, and distribute it  |
 | under the terms of the Affero General Public License Version 1,    |
 | March 2002.                                                        |
 |                                                                    |
 | CiviCRM is distributed in the hope that it will be useful, but     |
 | WITHOUT ANY WARRANTY; without even the implied warranty of         |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.               |
 | See the Affero General Public License for more details.            |
 |                                                                    |
 | You should have received a copy of the Affero General Public       |
 | License along with this program; if not, contact CiviCRM LLC       |
 | at info[AT]civicrm[DOT]org.  If you have questions about the       |
 | Affero General Public License or the licensing  of CiviCRM,        |
 | see the CiviCRM license FAQ at http://civicrm.org/licensing        |
 +--------------------------------------------------------------------+
*/

/**
 *
 * Stores all constants and pseudo constants for CRM application.
 *
 * examples of constants are "Contact Type" which will always be either
 * 'Individual', 'Household', 'Organization'.
 *
 * pseudo constants are entities from the database whose values rarely
 * change. examples are list of countries, states, location types,
 * relationship types.
 *
 * currently we're getting the data from the underlying database. this
 * will be reworked to use caching.
 *
 * @package CRM
 * @copyright CiviCRM LLC (c) 2004-2007
 * $Id$
 *
 */
$GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['locationType'] = null;
$GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['locationVcardName'] = null;
$GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['activityType'] = null;
$GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['individualPrefix'] = null;
$GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['individualSuffix'] = null;
$GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['gender'] = null;
$GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['imProvider'] = null;
$GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['stateProvince'] = null;
$GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['county'] = null;
$GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['stateProvinceAbbreviation'] = null;
$GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['country'] = null;
$GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['countryIsoCode'] = null;
$GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['tag'] = null;
$GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['group'] = null;
$GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['relationshipType'] = null;
$GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['staticGroup'] = null;
$GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['ufGroup'] = null;
$GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['customGroup'] = null;
$GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['currencyCode'] = null;
$GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['currencySymbols'] = null;
$GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['tasks'] = null;
$GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['pcm'] = null;
$GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['paymentProcessor'] = null;
$GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['paymentProcessorType'] = null;

class CRM_Core_PseudoConstant 
{
    /**
     * location type
     * @var array
     * @static
     */
    
    
    /**
     * location vCard name
     * @var array
     * @static
     */
    
    
    /**
     * activity type
     * @var array
     * @static
     */
    
  
    /**
     * individual prefix
     * @var array
     * @static
     */
    

    /**
     * individual suffix
     * @var array
     * @static
     */
    
    
    /**
     * gender
     * @var array
     * @static
     */
    

    /**
     * im protocols
     * @var array
     * @static
     */
    

    /**
     * states, provinces
     * @var array
     * @static
     */
    

    /**
     * counties
     * @var array
     * @static
     */
    

    /** 
     * states/provinces abbreviations
     * @var array
     * @static
     */
    

    /**
     * country
     * @var array
     * @static
     */
    


    /**
     * countryIsoCode
     * @var array
     * @static
     */
    

    /**
     * tag
     * @var array
     * @static
     */
    

    /**
     * group
     * @var array
     * @static
     */
    

    /**
     * relationshipType
     * @var array
     * @static
     */
    

    /**
     * civicrm groups that are not smart groups
     * @var array
     * @static
     */
    

    /**
     * user framework groups
     * @var array
     * @static
     */
    

    /**
     * custom groups
     * @var array
     * @static
     */
    

    /**
     * currency codes
     * @var array
     * @static
     */
    
    
    /**
     * currency Symbols
     * @var array
     * @static
     */
    
    
    /**
     * project tasks
     * @var array
     * @static
     */
    

    /**
     * preferred communication methods
     * @var array
     * @static
     */
    
    
    /**
     * payment processor
     * @var array
     * @static
     */
    
    
    /**
     * payment processor types
     * @var array
     * @static
     */
    
    
    /**
     * populate the object from the database. generic populate
     * method
     *
     * The static array $var is populated from the db
     * using the <b>$name DAO</b>. 
     *
     * Note: any database errors will be trapped by the DAO.
     *
     * @param array   $var        the associative array we will fill
     * @param string  $name       the name of the DAO
     * @param boolean $all        get all objects. default is to get only active ones.
     * @param string  $retrieve   the field that we are interested in (normally name, differs in some objects)
     * @param string  $filter     the field that we want to filter the result set with
     * @param string  $condition  the condition that gets passed to the final query as the WHERE clause
     *
     * @return void
     * @access public
     * @static
     */
      function populate( &$var, $name, $all = false, $retrieve = 'name',
                                     $filter = 'is_active', $condition = null, $orderby = null, $key = 'id' ) 
    {
        $cacheKey = "{$name}_{$all}_{$key}_{$retrieve}_{$filter}_{$condition}_{$orderby}";
        $cache =& CRM_Utils_Cache::singleton( );
        $var = $cache->get( $cacheKey );
        if ( $var ) {
            return $var;
        }

        require_once(str_replace('_', DIRECTORY_SEPARATOR, $name) . ".php");
        eval( '$object =& new ' . $name . '( );' );
        
        $object->domain_id = CRM_Core_Config::domainID( );
        $object->selectAdd( );
        $object->selectAdd( "$key, $retrieve" );
        if ($condition) {
            $object->whereAdd($condition);
        }
        
        if (!$orderby) {
            $object->orderBy( $retrieve );
        } else {
            $object->orderBy( $orderby );
        }
        
        if ( ! $all ) {
            $object->$filter = 1;
        }
        
        $object->find( );
        $var = array( );
        while ( $object->fetch( ) ) {
            $var[$object->$key] = $object->$retrieve;
        }

        $cache->set( $cacheKey, $var );
    }

    /**
     * Get all location types.
     *
     * The static array locationType is returned
     *
     * @access public
     * @static
     *
     * @param boolean $all - get All location types - default is to get only active ones.
     *
     * @return array - array reference of all location types.
     *
     */
      function &locationType( $all=false )
    {
        if ( ! $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['locationType'] ) {
            CRM_Core_PseudoConstant::populate( $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['locationType'], 'CRM_Core_DAO_LocationType', $all );
        }
        return $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['locationType'];
    }


    /**
     * Get all location vCard names.
     *
     * The static array locationVcardName is returned
     *
     * @access public
     * @static
     *
     * @param boolean $all - get All location vCard names - default is to get only active ones.
     *
     * @return array - array reference of all location vCard names.
     *
     */
      function &locationVcardName( $all=false )
    {
        if ( ! $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['locationVcardName'] ) {
            CRM_Core_PseudoConstant::populate( $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['locationVcardName'], 'CRM_Core_DAO_LocationType', $all, 'vcard_name' );
        }
        return $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['locationVcardName'];
    }

    /**
     * Get all Activty types.
     *
     * The static array activityType is returned
     *
     * @access public
     * @static
     *
     * @param boolean $all - get All Activity  types - default is to get only active ones.
     *
     * @return array - array reference of all activty types.
     *
     */
      function &activityType( $all = true )
    {
        require_once 'CRM/Core/OptionGroup.php';
        $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['activityType'] = CRM_Core_OptionGroup::values('activity_type');
        
        if ( $all ) {
            return $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['activityType'];
        } else {
            $otherActivities = array();
            foreach( $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['activityType'] as $key => $value ) {
                if ( $key > 4 ) {
                    $otherActivities [$key] = $value;
                }
            }
            return $otherActivities;
        }
    }

    /**
     * Get all Individual Prefix.
     *
     * The static array individualPrefix is returned
     *
     * @access public
     * @static
     *
     * @param boolean $all - get All Individual Prefix - default is to get only active ones.
     *
     * @return array - array reference of all individual prefix.
     *
     */
      function &individualPrefix( )
    {
        if ( ! $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['individualPrefix'] ) {
            require_once 'CRM/Core/OptionGroup.php';
            $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['individualPrefix'] = CRM_Core_OptionGroup::values('individual_prefix');
        }
        return $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['individualPrefix'];
    }

    /**
     * Get all Individual Suffix.
     *
     * The static array individualSuffix is returned
     *
     * @access public
     * @static
     *
     * @param boolean $all - get All Individual Suffix - default is to get only active ones.
     *
     * @return array - array reference of all individual suffix.
     *
     */
      function &individualSuffix( )
    {
        if ( ! $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['individualSuffix'] ) {
            require_once 'CRM/Core/OptionGroup.php';
            $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['individualSuffix'] = CRM_Core_OptionGroup::values('individual_suffix');
        }
        return $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['individualSuffix'];
    }

    /**
     * Get all Gender.
     *
     * The static array gender is returned
     *
     * @access public
     * @static
     *
     * @param boolean $all - get All Gender - default is to get only active ones.
     *
     * @return array - array reference of all gender.
     *
     */
      function &gender( )
    {
        if ( ! $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['gender'] ) {
            require_once 'CRM/Core/OptionGroup.php';
            $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['gender'] = CRM_Core_OptionGroup::values('gender');
        }
        return $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['gender'];
    }


    /**
     * Get all the IM Providers from database.
     *
     * The static array imProvider is returned, and if it's
     * called the first time, the <b>IM DAO</b> is used 
     * to get all the IM Providers.
     *
     * Note: any database errors will be trapped by the DAO.
     *
     * @access public
     * @static
     *
     * @return array - array reference of all IM providers.
     *
     */
      function &IMProvider( ) 
    {
        if ( ! $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['imProvider'] ) {
            require_once 'CRM/Core/OptionGroup.php';
            $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['imProvider'] = CRM_Core_OptionGroup::values('instant_messenger_service');
        }        
        return $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['imProvider'];
    }

    /**
     * Get all the State/Province from database.
     *
     * The static array stateProvince is returned, and if it's
     * called the first time, the <b>State Province DAO</b> is used 
     * to get all the States.
     *
     * Note: any database errors will be trapped by the DAO.
     *
     * @access public
     * @static
     *
     * @param int $id -  Optional id to return
     * @return array - array reference of all State/Provinces.
     *
     */
      function &stateProvince($id = false, $limit = true)
    {
        if ( !$GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['stateProvince'] || !$id ) {
            $whereClause = false;
            $config =& CRM_Core_Config::singleton();
            if ( $limit ) {
                // limit the state/province list to the countries specified in CIVICRM_PROVINCE_LIMIT
                $countryIsoCodes =& CRM_Core_PseudoConstant::countryIsoCode();
                $limitCodes = $config->provinceLimit( );
                $limitIds = array();
                foreach ($limitCodes as $code) {
                    $limitIds = array_merge($limitIds, array_keys($countryIsoCodes, $code));
                }
                if ( !empty($limitIds) ) {
                    $whereClause = 'country_id IN (' . implode(', ', $limitIds) . ')';
                } else {
                    $whereClause = false;
                }
            }
            CRM_Core_PseudoConstant::populate( $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['stateProvince'], 'CRM_Core_DAO_StateProvince', true, 'name', 'is_active', $whereClause );

            // localise the province names if in an non-en_US locale
            if ($config->lcMessages != '' and $config->lcMessages != 'en_US') {
                $i18n =& CRM_Core_I18n::singleton();
                $i18n->localizeArray($GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['stateProvince']);
                asort($GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['stateProvince']);
            }
        }
        if ( $id ) {
            if ( array_key_exists( $id, $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['stateProvince']) ) {
                return $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['stateProvince'][$id];
            } else {
                $result = null;
                return $result;
            }
        }
        return $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['stateProvince'];
    }

    /**
     * Get all the State/Province abbreviations from the database.
     * 
     * Same as above, except gets the abbreviations instead of the names.
     *
     * @access public
     * @static
     * @param int $id  -     Optional id to return
     * @return array - array reference of all State/Province abbreviations.
     */
      function &stateProvinceAbbreviation($id = false, $limit = true )
    {
        if (!$GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['stateProvinceAbbreviation'] || !$id ) {

            // limit the state/province list to the countries specified in CIVICRM_PROVINCE_LIMIT
            $whereClause = false;

            if ( $limit ) {
                $config =& CRM_Core_Config::singleton();
                $countryIsoCodes =& CRM_Core_PseudoConstant::countryIsoCode();
                $limitCodes = $config->provinceLimit( );
                $limitIds = array();
                foreach ($limitCodes as $code) {
                    $tmpArray   = array_keys($countryIsoCodes, $code);
                    
                    if (!empty($tmpArray)) {
                        $limitIds[] = array_shift($tmpArray);
                    }
                }
                if ( !empty($limitIds) ) {
                    $whereClause = 'country_id IN (' . implode(', ', $limitIds) . ')';
                }
            } 
            CRM_Core_PseudoConstant::populate( $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['stateProvinceAbbreviation'], 'CRM_Core_DAO_StateProvince', true, 'abbreviation', 'is_active', $whereClause );
        }

        if ($id) {
            if (array_key_exists( $id, $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['stateProvinceAbbreviation']) ) {
                return $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['stateProvinceAbbreviation'][$id];
            } else {
                $result = null;
                return $result;
            }
        }
        return $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['stateProvinceAbbreviation'];
    }


    /**
     * Get all the countries from database.
     *
     * The static array country is returned, and if it's
     * called the first time, the <b>Country DAO</b> is used 
     * to get all the countries.
     *
     * Note: any database errors will be trapped by the DAO.
     *
     * @access public
     * @static
     *
     * @param int $id - Optional id to return
     * @return array - array reference of all countries.
     *
     */
      function country($id = false) 
    {
        if ( !$GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['country'] || !$id ) {

            $config =& CRM_Core_Config::singleton();

            // limit the country list to the countries specified in CIVICRM_COUNTRY_LIMIT
            // (ensuring it's a subset of the legal values)
            // K/P: We need to fix this, i dont think it works with new setting files
            $limitCodes = $config->countryLimit( );
            if ( ! is_array( $limitCodes ) ) {
                $limitCodes = array( $config->countryLimit => 1);
            }

            $limitCodes = array_intersect(CRM_Core_PseudoConstant::countryIsoCode(), $limitCodes);
            if (count($limitCodes)) {
                $whereClause = "iso_code IN ('" . implode("', '", $limitCodes) . "')";
            } else {
                $whereClause = null;
            }

            CRM_Core_PseudoConstant::populate( $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['country'], 'CRM_Core_DAO_Country', true, 'name', 'is_active', $whereClause );

            // if default country is set, percolate it to the top
            if ( $config->defaultContactCountry( ) ) {
                $countryIsoCodes =& CRM_Core_PseudoConstant::countryIsoCode();
                $defaultID = array_search($config->defaultContactCountry( ), $countryIsoCodes); 
                if ( $defaultID !== false ) {
                    $default[$defaultID] = $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['country'][$defaultID];
                    $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['country'] = $default + $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['country'];
                }
            }

            // localise the country names if in an non-en_US locale
            if ($config->lcMessages != '' and $config->lcMessages != 'en_US') {
                $i18n =& CRM_Core_I18n::singleton();
                $i18n->localizeArray($GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['country']);
                asort($GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['country']);
            }
        }
        if ($id) {
            if (array_key_exists( $id , $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['country'])) {
                return $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['country'][$id];
            } else {
                return null;
            }
        }
        return $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['country'];
    }

    /**
     * Get all the country ISO Code abbreviations from the database.
     *
     * The static array countryIsoCode is returned, and if it's
     * called the first time, the <b>Country DAO</b> is used
     * to get all the countries' ISO codes.
     *
     * Note: any database errors will be trapped by the DAO.
     *
     * @access public
     * @static
     *
     * @return array - array reference of all country ISO codes.
     *
     */
      function &countryIsoCode( $id = false )
    {
        if (!$GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['countryIsoCode']) {
            CRM_Core_PseudoConstant::populate( $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['countryIsoCode'], 'CRM_Core_DAO_Country',
                            true, 'iso_code');
        }
        if ($id) { 
            if (array_key_exists($id, $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['countryIsoCode'])) { 
                return $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['countryIsoCode'][$id]; 
            } else { 
                return null; 
            } 
        } 
        return $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['countryIsoCode'];
    }

    /**
     * Get all the categories from database.
     *
     * The static array tag is returned, and if it's
     * called the first time, the <b>Tag DAO</b> is used 
     * to get all the categories.
     *
     * Note: any database errors will be trapped by the DAO.
     *
     * @access public
     * @static
     *
     * @return array - array reference of all categories.
     *
     */
      function &tag()
    {
        if (!$GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['tag']) {
            CRM_Core_PseudoConstant::populate( $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['tag'], 'CRM_Core_DAO_Tag', true );
        }
        return $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['tag'];
    }

    /**
    * Get all groups from database
    *
    * The static array group is returned, and if it's
    * called the first time, the <b>Group DAO</b> is used
    * to get all the groups.
    *
    * Note: any database errors will be trapped by the DAO.
    *
    * @access public
    * @static
    *
    * @return array - array reference of all groups.
    *
    */
      function &allGroup()
    {
        if (!$GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['group']) {
            CRM_Core_PseudoConstant::populate( $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['group'], 'CRM_Contact_DAO_Group', false, 'title' );
        }
        return $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['group'];
    }

    /**
     * Get all permissioned groups from database
     *
     * The static array group is returned, and if it's
     * called the first time, the <b>Group DAO</b> is used 
     * to get all the groups.
     *
     * Note: any database errors will be trapped by the DAO.
     *
     * @access public
     * @static
     *
     * @return array - array reference of all groups.
     *
     */
      function group()
    {
        require_once 'CRM/Core/Permission.php';
        return CRM_Core_Permission::group( );
    }

    /**
     * Get all permissioned groups from database
     *
     * The static array group is returned, and if it's
     * called the first time, the <b>Group DAO</b> is used 
     * to get all the groups.
     *
     * Note: any database errors will be trapped by the DAO.
     *
     * @access public
     * @static
     *
     * @return array - array reference of all groups.
     *
     */
      function &staticGroup( $onlyPublic = false )
    {
        if ( ! $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['staticGroup'] ) {
            $condition = 'saved_search_id = 0 OR saved_search_id IS NULL';
            if ( $onlyPublic ) {
                $condition .= " and visibility != 'User and User Admin Only'";
            }
            CRM_Core_PseudoConstant::populate( $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['staticGroup'], 'CRM_Contact_DAO_Group', false, 'title', 'is_active', $condition, 'title' );
        }
        return $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['staticGroup'];        
    }

    /**
     * Get all the custom groups
     *
     * @access public
     * @return array - array reference of all groups.
     * @static
     */
      function &customGroup( )
    {
        if ( ! $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['customGroup'] ) {
            CRM_Core_PseudoConstant::populate( $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['customGroup'], 'CRM_Core_DAO_CustomGroup', false, 'title', 'is_active', null, 'title' );
        }
        return $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['customGroup'];
    }

    /**
     * Get all the user framework groups
     *
     * @access public
     * @return array - array reference of all groups.
     * @static
     */
      function &ufGroup( )
    {
        if ( ! $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['ufGroup'] ) {
            CRM_Core_PseudoConstant::populate( $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['ufGroup'], 'CRM_Core_DAO_UFGroup', false, 'title', 'is_active', null, 'title' );
        }
        return $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['ufGroup'];
    }

    /**
     * Get all the project tasks
     *
     * @access public
     * @return array - array reference of all tasks
     * @static
     */
      function &tasks( )
    {
        if ( ! $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['tasks'] ) {
            CRM_Core_PseudoConstant::populate( $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['tasks'], 'CRM_Project_DAO_Task', false, 'title', 'is_active', null, 'title' );
        }
        return $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['tasks'];
    }

    /**
     * Get all Relationship Types  from database.
     *
     * The static array group is returned, and if it's
     * called the first time, the <b>RelationshipType DAO</b> is used 
     * to get all the relationship types.
     *
     * Note: any database errors will be trapped by the DAO.
     *
     * @access public
     * @static
     *
     * @return array - array reference of all relationship types.
     *
     */
      function &relationshipType()
    {
        if (!$GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['relationshipType']) {
            $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['relationshipType'] = array();
            require_once 'CRM/Contact/DAO/RelationshipType.php';
            $relationshipTypeDAO =& new CRM_Contact_DAO_RelationshipType();
            $relationshipTypeDAO->selectAdd();
            $relationshipTypeDAO->selectAdd('id, name_a_b, name_b_a, contact_type_a, contact_type_b');
            $relationshipTypeDAO->is_active = 1;
            $relationshipTypeDAO->find();
            while($relationshipTypeDAO->fetch()) {
                $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['relationshipType'][$relationshipTypeDAO->id] = array(
                                                                          'name_a_b'       => "$relationshipTypeDAO->name_a_b",
                                                                          'name_b_a'       => "$relationshipTypeDAO->name_b_a",
                                                                          'contact_type_a' => "$relationshipTypeDAO->contact_type_a",
                                                                          'contact_type_b' => "$relationshipTypeDAO->contact_type_b",
                                                                         );
            }
        }
        return $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['relationshipType'];
    }

    /**
     * Get all the Currency Symbols from Database
     *
     * @access public
     * @return array - array reference of all Currency Symbols
     * @static
     */
      function &currencySymbols( $name = 'symbol' )
    {
        CRM_Core_PseudoConstant::populate( $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['currencySymbols'], 'CRM_Core_DAO_Currency', true, $name, null, null, 'name');
        return $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['currencySymbols'];
    }

    /**
     * get all the ISO 4217 currency codes
     *
     * so far, we use this for validation only, so there's no point of putting this into the database
     *
     * @access public
     * @return array - array reference of all currency codes
     * @static
     */
      function &currencyCode()
    {
        if (!$GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['currencyCode']) {
            $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['currencyCode'] = array('AFN','ALL','DZD','USD','EUR','AOA','XCD','XCD','ARS','AMD',
                'AWG','AUD','EUR','AZM','BSD','BHD','BDT','BBD','BYR','EUR','BZD','XOF','BMD','INR',
                'BTN','BOB','BOV','BAM','BWP','NOK','BRL','USD','BND','BGN','XOF','BIF','KHR','XAF',
                'CAD','CVE','KYD','XAF','XAF','CLP','CLF','CNY','AUD','AUD','COP','COU','KMF','XAF',
                'CDF','NZD','CRC','XOF','HRK','CUP','CYP','CZK','DKK','DJF','XCD','DOP','USD','EGP',
                'SVC','USD','XAF','ERN','EEK','ETB','FKP','DKK','FJD','EUR','EUR','EUR','XPF','EUR',
                'XAF','GMD','GEL','EUR','GHC','GIP','EUR','DKK','XCD','EUR','USD','GTQ','GNF','GWP',
                'XOF','GYD','HTG','USD','AUD','EUR','HNL','HKD','HUF','ISK','INR','IDR','XDR','IRR',
                'IQD','EUR','ILS','EUR','JMD','JPY','JOD','KZT','KES','AUD','KPW','KRW','KWD','KGS',
                'LAK','LVL','LBP','ZAR','LSL','LRD','LYD','CHF','LTL','EUR','MOP','MKD','MGA','MWK',
                'MYR','MVR','XOF','MTL','USD','EUR','MRO','MUR','EUR','MXN','MXV','USD','MDL','EUR',
                'MNT','XCD','MAD','MZM','MMK','ZAR','NAD','AUD','NPR','EUR','ANG','XPF','NZD','NIO',
                'XOF','NGN','NZD','AUD','USD','NOK','OMR','PKR','USD','PAB','USD','PGK','PYG','PEN',
                'PHP','NZD','PLN','EUR','USD','QAR','EUR','ROL','RON','RUB','RWF','SHP','XCD','XCD',
                'EUR','XCD','WST','EUR','STD','SAR','XOF','CSD','EUR','SCR','SLL','SGD','SKK','SIT',
                'SBD','SOS','ZAR','EUR','LKR','SDD','SRD','NOK','SZL','SEK','CHF','CHW','CHE','SYP',
                'TWD','TJS','TZS','THB','USD','XOF','NZD','TOP','TTD','TND','TRY','TRL','TMM','USD',
                'AUD','UGX','UAH','AED','GBP','USD','USS','USN','USD','UYU','UZS','VUV','VEB','VND',
                'USD','USD','XPF','MAD','YER','ZMK','ZWD','XAU','XBA','XBB','XBC','XBD','XPD','XPT',
                'XAG','XFU','XFO','XTS','XXX');
        }
        return $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['currencyCode'];
    }

    /**
     * Get all the County from database.
     *
     * The static array county is returned, and if it's
     * called the first time, the <b>County DAO</b> is used 
     * to get all the Counties.
     *
     * Note: any database errors will be trapped by the DAO.
     *
     * @access public
     * @static
     *
     * @param int $id -  Optional id to return
     * @return array - array reference of all Counties
     *
     */
      function &county($id = false)
    {
        if (!$GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['county']) {

            $config =& CRM_Core_Config::singleton();
            // order by id so users who populate civicrm_county can have more control over sort by the order they load the counties
            CRM_Core_PseudoConstant::populate( $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['county'], 'CRM_Core_DAO_County', true, 'name', null, null, 'id');
        }
        if ($id) {
            if (array_key_exists($id, $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['county'])) {
                return $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['county'][$id];
            } else {
                return null;
            }
        }
        return $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['county'];
    }

    /**
     * Get all the Preferred Communication Methods from database.
     *
     * @access public
     * @static
     *
     * @return array self::pcm - array reference of all preferred communication methods.
     *
     */
      function &pcm( ) 
    {
        if ( ! $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['pcm'] ) {
            require_once 'CRM/Core/OptionGroup.php';
            $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['pcm'] = CRM_Core_OptionGroup::values('preferred_communication_method');
        }        
        return $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['pcm'];
    }

    /**
     * Get all active payment processors
     *
     * The static array paymentProcessor is returned
     *
     * @access public
     * @static
     *
     * @param boolean $all  - get payment processors     - default is to get only active ones.
     * @param boolean $test - get test payment processors
     *
     * @return array - array of all payment processors
     *
     */
      function &paymentProcessor( $all = false, $test = false, $additionalCond = null )
    {
        $condition  = "is_test = ";
        $condition .=  ( $test ) ? '1' : '0';

        if ( $additionalCond ) {
            $condition .= " AND ( $additionalCond ) ";
        }

        if ( ! $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['paymentProcessor'] ) {
            CRM_Core_PseudoConstant::populate( $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['paymentProcessor'], 'CRM_Core_DAO_PaymentProcessor', $all, 
                            'name', 'is_active', $condition, 'is_default desc, name' );
        }
        return $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['paymentProcessor'];
    }

    /**
     * Get all active payment processors
     *
     * The static array paymentProcessorType is returned
     *
     * @access public
     * @static
     *
     * @param boolean $all  - get payment processors     - default is to get only active ones.
     *
     * @return array - array of all payment processor types
     *
     */
      function &paymentProcessorType( $all = false )
    {
        if ( ! $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['paymentProcessorType'] ) {
            CRM_Core_PseudoConstant::populate( $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['paymentProcessorType'], 'CRM_Core_DAO_PaymentProcessorType', $all, 
                            'title', 'is_active', null, 'is_default, title', 'name' );
        }
        return $GLOBALS['_CRM_CORE_PSEUDOCONSTANT']['paymentProcessorType'];
    }
}

?>